;==========================================================================================
; Description:      Brain Pain - BassMod Play Function
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to un4seen for BassMod.dll
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

Global Const $GUI_BKCOLOR_TRANSPARENT = -2
Global Const $WS_POPUP = 0x80000000
Global Const $WS_BORDER = 0x00800000
Global Const $GUI_SHOW = 16
Global Const $GUI_HIDE = 32
Global Const $GUI_ENABLE = 64
Global Const $GUI_DISABLE = 128
; Label/Pic/Icon
Global Const $SS_LEFT = 0
Global Const $SS_CENTER = 1
Global Const $SS_SUNKEN = 0x1000
Global Const $SS_CENTERIMAGE = 0x0200
; Graphic
Global Const $GUI_GR_CLOSE = 1
Global Const $GUI_GR_LINE = 2
Global Const $GUI_GR_BEZIER = 4
Global Const $GUI_GR_MOVE = 6
Global Const $GUI_GR_COLOR = 8
Global Const $GUI_GR_RECT = 10
Global Const $GUI_GR_ELLIPSE = 12
Global Const $GUI_GR_PIE = 14
Global Const $GUI_GR_DOT = 16
Global Const $GUI_GR_PIXEL = 18
Global Const $GUI_GR_HINT = 20
Global Const $GUI_GR_REFRESH = 22
Global Const $GUI_GR_PENSIZE = 24
Global Const $GUI_GR_NOBKCOLOR = -2


Local $SoundsPath = @ScriptDir & "\..\Resources\Sounds\"
Local $MusicsPath = @ScriptDir & "\..\Resources\Music\"
Local $PicPath = @ScriptDir & "\..\Resources\Pictures\"
Local $PicPaths = @ScriptDir & "\..\Resources\Pictures\Circles\"
Local $SoundPath = @ScriptDir & "\..\Resources\Sounds\"
Local $languagePath = @ScriptDir & "\..\Resources\Language\language.ini"
Local $Path = @ScriptDir & "\..\Resources\Pictures\Cash\"
Local $NumberPath =  @ScriptDir & "\..\Resources\Pictures\Numbers\"
Local $PicPathAlfa = @ScriptDir & "\..\Resources\Pictures\Alfa\"
Local $PicPathBeta = @ScriptDir & "\..\Resources\Pictures\Beta\"
Local $PicPathBeta2 = @ScriptDir & "\..\Resources\Pictures\Gamma\"
Local $bassdll, $Init[1], $Result, $Amount, $ToType

Global $objLang = ObjCreate('Scripting.Dictionary')

Func _PlaySong()
	If FileExists($MusicsPath & "BASSMOD.dll") Then
		Global $MusicArray[8] = ["Track1.xm", "Track2.xm", "Track3.mod", "Track4.xm", _
				"Track5.xm", "Track6.xm", "Track7.mod", "Track8.mod"]
		$R_Music = Random(0, UBound($MusicArray) - 1, 1)
		$bassdll = DllOpen($MusicsPath & "BASSMOD.dll")
		$Init = DllCall($bassdll, "int", "BASSMOD_Init", "int", -1, "int", 44100, "int", 0)
		$Name_H = DllStructCreate("char[255]")
		DllStructSetData($Name_H, 1, $MusicsPath & $MusicArray[$R_Music])
		$Lod = DllCall($bassdll, "int", "BASSMOD_MusicLoad", "int", 0, _
				"ptr", DllStructGetPtr($Name_H), _
				"int", 0, _
				"int", 0, _
				"int", 1028)
		$nay = DllCall($bassdll, "int:cdecl", "BASSMOD_MusicPlay", "int", $Init[0])
	EndIf
EndFunc   ;==>_PlaySong

Func _PrePare($x_Pos, $y_Pos, $ColorId)
	Local $Numb[3] = ["3", "2", "1"  ], $Fake
	$Fake = GUICtrlCreateLabel("", $x_Pos, $y_Pos, 80, 150)
	GUICtrlSetFont(-1, 100, 900)
	GUICtrlSetColor(-1, $ColorId)
	GUICtrlSetBkColor(-1, -2)
	For $m = 0 To 2
		GUICtrlSetData($Fake, $Numb[$m])
		SoundPlay($SoundsPath & "time.wav")
		Sleep(1000)
	Next
	GUICtrlDelete($Fake)
EndFunc   ;==>_PrePare

Func _FlashControl($CtrlId, $Duration)
	For $i = 1 To 2
		GUICtrlSetState($CtrlId, 32)
		Sleep($Duration)
		GUICtrlSetState($CtrlId, 16)
		Sleep($Duration)
	Next
EndFunc   ;==>_FlashControl

Func _Results($CtrlId, $Amount, $Mt, $Game_Sec)
	If Not FileExists("Save.ini") Then FileWrite("Save.ini", "")
	If $Mt = 1 Then
		If $Amount = 10 Then
			$Result = _ObjDictGetValue($objLang, 'Perfect')
		ElseIf $Amount = 9 Then
			$Result = _ObjDictGetValue($objLang, 'Excellent')
		ElseIf $Amount = 8 Or $Amount = 7 Then
			$Result = _ObjDictGetValue($objLang, 'PrettyGood')
		ElseIf $Amount = 6 Or $Amount = 5 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount <= 4 Then
			$Result = _ObjDictGetValue($objLang, 'TryAgain')
		EndIf
		$ToType = $Amount * 10
	ElseIf $Mt = 2 Then
		If $Amount = 15 Then
			$Result = _ObjDictGetValue($objLang, 'Perfect')
		ElseIf $Amount = 14 Or $Amount = 13 Then
			$Result = _ObjDictGetValue($objLang, 'Excellent')
		ElseIf $Amount = 12 Or $Amount = 11 Then
			$Result = _ObjDictGetValue($objLang, 'PrettyGood')
		ElseIf $Amount = 10 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount = 9 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount = 8 Or $Amount = 7 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount <= 6 Then
			$Result = _ObjDictGetValue($objLang, 'TryAgain')
		EndIf
		$ToType = Round(($Amount * 100) / 15)
	ElseIf $Mt = 3 Then
		If $Amount = 20 Then
			$Result = _ObjDictGetValue($objLang, 'Perfect')
		ElseIf $Amount = 19 Or $Amount = 18 Then
			$Result = _ObjDictGetValue($objLang, 'Excellent')
		ElseIf $Amount = 17 Or $Amount = 16 Then
			$Result = _ObjDictGetValue($objLang, 'PrettyGood')
		ElseIf $Amount = 15 Or $Amount = 14 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount = 13 Or $Amount = 12 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount = 11 Or $Amount = 10 Then
			$Result = _ObjDictGetValue($objLang, 'NotBad')
		ElseIf $Amount <= 9 Then
			$Result = _ObjDictGetValue($objLang, 'TryAgain')
		EndIf
		$ToType = ($Amount * 100) / 20
	EndIf
	$IniR = IniRead("Save.ini", "Games", $Game_Sec, "")
	If $IniR = "" Or $IniR < $ToType Then IniWrite("Save.ini", "Games", $Game_Sec, $ToType)
	SoundPlay($SoundsPath & "Result.wav")
	GUICtrlSetData($CtrlId, $ToType & "% " & $Result)
EndFunc   ;==>_Results

Func Close()
	If FileExists($MusicsPath & "BASSMOD.dll") Then
		DllCall($bassdll, "int:cdecl", "BASSMOD_MusicFree", "int", $Init[0])
		DllClose($bassdll)
	EndIf
	Run(@ScriptDir & "\..\BrainPain.exe " & IniRead(@ScriptDir & "\..\Resources\Language\language.ini", 'Setting', 'Language', 'English'))
	Exit
EndFunc   ;==>Close

;===============================================================================
;
; Function Name:  _ArrayDelete()
; Description:    Deletes the specified element from the given array, returning
;                 the adjusted array.
; Author(s)       Cephas <cephas at clergy dot net>
; Modifications   Array is passed via Byref  - Jos van der zande
;===============================================================================
Func _ArrayDelete(ByRef $avArray, $iElement)
	Local $iCntr = 0, $iUpper = 0

	If (Not IsArray($avArray)) Then
		SetError(1)
		Return ""
	EndIf

	; We have to define this here so that we're sure that $avArray is an array
	; before we get it's size.
	$iUpper = UBound($avArray)    ; Size of original array

	; If the array is only 1 element in size then we can't delete the 1 element.
	If $iUpper = 1 Then
		SetError(2)
		Return ""
	EndIf

	Local $avNewArray[$iUpper - 1]
	If $iElement < 0 Then
		$iElement = 0
	EndIf
	If $iElement > ($iUpper - 1) Then
		$iElement = ($iUpper - 1)
	EndIf
	If $iElement > 0 Then
		For $iCntr = 0 To $iElement - 1
			$avNewArray[$iCntr] = $avArray[$iCntr]
		Next
	EndIf
	If $iElement < ($iUpper - 1) Then
		For $iCntr = ($iElement + 1) To ($iUpper - 1)
			$avNewArray[$iCntr - 1] = $avArray[$iCntr]
		Next
	EndIf
	$avArray = $avNewArray
	SetError(0)
	Return 1
EndFunc   ;==>_ArrayDelete

;===============================================================================
;
; Function Name:  _ArraySwap()
; Description:    Swaps two elements of an array.
; Author(s):      David Nuttall <danuttall at rocketmail dot com>
;
;===============================================================================
Func _ArraySwap(ByRef $svector1, ByRef $svector2)
	Local $sTemp = $svector1

	$svector1 = $svector2
	$svector2 = $sTemp

	SetError(0)
EndFunc   ;==>_ArraySwap

Func _getLanguage(ByRef $obj, $language)
	Global $lang_A = IniReadSection($languagePath, $language)
	If @error Then
		MsgBox(4096, "Error", "Error occurred, probably no langauge INI file.")
		Exit (0)
	EndIf

	For $i = 1 To $lang_A[0][0]
		_ObjDictAdd($obj, $lang_A[$i][0], $lang_A[$i][1])
	Next
EndFunc   ;==>_getLanguage

;==================================================================================================
; Parameter: $oDICT - Handle des Dictionary-Objektes
;            $KEY   - Schlssel
; Return:    Erfolg:  Wert des Schlssels
;            Fehler:  -1
;        Fehlerwert:   1  Objekt existiert nicht
;                      2  Schlssel ohne Inhalt bergeben
;                      5  Schlssel nicht vorhanden
;==================================================================================================
Func _ObjDictGetValue(ByRef $oDICT, $KEY)
	If Not IsObj($oDICT) Then
		SetError(1)
		Return -1
	ElseIf $KEY = '' Then
		SetError(2)
		Return -1
	ElseIf Not $oDICT.Exists($KEY) Then
		SetError(5)
		Return -1
	EndIf
	Return $oDICT.Item($KEY)
EndFunc   ;==>_ObjDictGetValue

;==================================================================================================
; Parameter: $oDICT - Handle des Dictionary-Objektes
;            $KEY   - Schlssel
;            $VALUE - Wert
; Return:    Erfolg:   0
;            Fehler:  -1
;        Fehlerwert:   1  Objekt existiert nicht
;                      2  Schlssel ohne Inhalt bergeben
;                      3  Wert hat keinen Inhalt
;                      4  Schlssel bereits vorhanden
;==================================================================================================
Func _ObjDictAdd(ByRef $oDICT, $KEY, $VALUE)
	If Not IsObj($oDICT) Then
		SetError(1)
		Return -1
	ElseIf $KEY = '' Then
		SetError(2)
		Return -1
	ElseIf $VALUE = '' Then
		SetError(3)
		Return -1
	ElseIf $oDICT.Exists($KEY) Then
		SetError(4)
		Return -1
	EndIf
	$oDICT.Add($KEY, $VALUE)
	Return 0
EndFunc   ;==>_ObjDictAdd