;==========================================================================================
; Description:      Brain Pain - Game 25 Level 1
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $xPos = -15, $SetC, $Count, $Score, $PcA[36], $PkA[9], $Warray
Local $Gr[4], $x, $y, $xy, $yx

$Hui = GUICreate("Brain Pain", 500, 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, 600, 335)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlSetState(-1, $GUI_DISABLE)

GUICtrlCreateGraphic(410, 5, 85, 35)
GUICtrlSetColor(-1, 0x4A66FA)
GUICtrlCreateGraphic(0, 45, 500, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 380, 500, 1)
GUICtrlSetColor(-1, 0x000000)

$label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game25Q'), 5, 390, 600, 15)
GUICtrlSetColor($label1, 0x4A66FA)
$Time = GUICtrlCreateLabel("04:00", 420, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor($Time, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor($Label2, 0x4A66FA)
GUISetState()

_PrePare(210, 135, 0x4A66FA)

GUISetOnEvent(-3, "Close")

CreateGraF()

_PlaySong()

For $a = 1 To 10
	BlocksPos()
	ArraySwaP()
	Timer()
Next

_Results($Label2, $Score, 1, "G25-L1")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 3
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func CreateGraF()
	GUICtrlCreateGraphic(80, 190, 49, 49)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x9B9B9B)
	$xy = 190
	$x = 80
	CreateGr1()
	$xy = 80
	$y = 190
	CreateGr2()

	$Gr[0] = GUICtrlCreateGraphic(260, 145, 49, 49)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x9B9B9B)
	$xy = 145
	$x = 260
	CreateGr1()
	$xy = 260
	$y = 145
	CreateGr2()
	GUICtrlSetCursor($Gr[0], 0)

	$Gr[1] = GUICtrlCreateGraphic(380, 145, 49, 49)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x9B9B9B)
	$xy = 145
	$x = 380
	CreateGr1()
	$xy = 380
	$y = 145
	CreateGr2()
	GUICtrlSetCursor($Gr[1], 0)

	$Gr[2] = GUICtrlCreateGraphic(260, 240, 49, 49)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x9B9B9B)
	$xy = 240
	$x = 260
	CreateGr1()
	$xy = 260
	$y = 240
	CreateGr2()
	GUICtrlSetCursor($Gr[2], 0)

	$Gr[3] = GUICtrlCreateGraphic(380, 240, 49, 49)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetBkColor(-1, 0x9B9B9B)
	$xy = 240
	$x = 380
	CreateGr1()
	$xy = 380
	$y = 240
	CreateGr2()
	GUICtrlSetCursor($Gr[3], 0)
EndFunc

Func CreateGr1()
	For $o = 1 To 2
		$xy += 16
		GUICtrlCreateGraphic($x, $xy, 49, 1)
		GUICtrlSetBkColor(-1, 0x000000)
		GUICtrlSetState(-1, $GUI_DISABLE)
	Next
EndFunc

Func CreateGr2()
	For $o = 1 To 2
		$xy += 16
		GUICtrlCreateGraphic($xy, $y, 1, 49)
		GUICtrlSetBkColor(-1, 0x000000)
		GUICtrlSetState(-1, $GUI_DISABLE)
	Next
EndFunc

Func BlocksPos()
	Global $ig[9] = ["81,191", "97,191", "113,191", _
			"81,207", "97,207", "113,207", _
			"81,223", "97,223", "113,223"]
	Global $Warray[1]
	For $o = 0 To 3
		$Ran_Y = Random(0, UBound($ig) - 1, 1)
		ReDim $Warray[UBound($Warray) + 1]
		$Warray[0] = $Warray[0] + 1
		$Warray[UBound($Warray) - 1] = $ig[$Ran_Y]
		$Split = StringSplit($ig[$Ran_Y], ",")
		$PkA[$o] = GUICtrlCreatePic($PicPath & "block.bmp", $Split[1], $Split[2], 15, 15)
		_ArrayDelete($ig, $Ran_Y)
	Next
EndFunc

Func ArraySwaP()
	$svp = Random(1, 3, 1)
	If $svp = 1 Then
		For $x = 1 To $Warray[0]
			If $Warray[$x] = "81,191"  Then
				$Warray[$x] = "113,223" 
			ElseIf $Warray[$x] = "81,207"  Then
				$Warray[$x] = "113,207," 
			ElseIf $Warray[$x] = "81,223"  Then
				$Warray[$x] = "113,191" 
			ElseIf $Warray[$x] = "97,191"  Then
				$Warray[$x] = "97,223" 
			ElseIf $Warray[$x] = "97,207"  Then
				$Warray[$x] = "97,207" 
			ElseIf $Warray[$x] = "97,223"  Then
				$Warray[$x] = "97,191" 
			ElseIf $Warray[$x] = "113,191"  Then
				$Warray[$x] = "81,223" 
			ElseIf $Warray[$x] = "113,207"  Then
				$Warray[$x] = "81,207" 
			ElseIf $Warray[$x] = "113,223"  Then
				$Warray[$x] = "81,191" 
			EndIf
		Next
	ElseIf $svp = 2 Then
		For $x = 1 To $Warray[0]
			If $Warray[$x] = "81,191"  Then
				$Warray[$x] = "113,191" 
			ElseIf $Warray[$x] = "81,207"  Then
				$Warray[$x] = "97,191," 
			ElseIf $Warray[$x] = "81,223"  Then
				$Warray[$x] = "81,191" 
			ElseIf $Warray[$x] = "97,191"  Then
				$Warray[$x] = "113,207" 
			ElseIf $Warray[$x] = "97,207"  Then
				$Warray[$x] = "97,207" 
			ElseIf $Warray[$x] = "97,223"  Then
				$Warray[$x] = "81,207" 
			ElseIf $Warray[$x] = "113,191"  Then
				$Warray[$x] = "113,223" 
			ElseIf $Warray[$x] = "113,207"  Then
				$Warray[$x] = "97,223" 
			ElseIf $Warray[$x] = "113,223"  Then
				$Warray[$x] = "81,223" 
			EndIf
		Next
	ElseIf $svp = 3 Then
		For $x = 1 To $Warray[0]
			If $Warray[$x] = "81,191"  Then
				$Warray[$x] = "81,223" 
			ElseIf $Warray[$x] = "81,207"  Then
				$Warray[$x] = "97,223," 
			ElseIf $Warray[$x] = "81,223"  Then
				$Warray[$x] = "113,223" 
			ElseIf $Warray[$x] = "97,191"  Then
				$Warray[$x] = "81,207" 
			ElseIf $Warray[$x] = "97,207"  Then
				$Warray[$x] = "97,207" 
			ElseIf $Warray[$x] = "97,223"  Then
				$Warray[$x] = "113,207" 
			ElseIf $Warray[$x] = "113,191"  Then
				$Warray[$x] = "81,191" 
			ElseIf $Warray[$x] = "113,207"  Then
				$Warray[$x] = "97,191" 
			ElseIf $Warray[$x] = "113,223"  Then
				$Warray[$x] = "113,191" 
			EndIf
		Next
	EndIf
	RandomPos()
	$SetC = 0
EndFunc

Func RandomPos()
	For $a = 0 To UBound($Gr)-1
		GUICtrlSetOnEvent($Gr[$a], "WrongAnW")
	Next
	$Rrn = Random(1, 4, 1)
	If $Rrn = 1 Then
		SetPos1()
	ElseIf $Rrn = 2 Then
		SetPos2()
	ElseIf $Rrn = 3 Then
		SetPos3()
	ElseIf $Rrn = 4 Then
		SetPos4()
	EndIf
EndFunc

Func SetPos1()
	For $p = 1 To 4
		$Split = StringSplit($Warray[$p], ",")
		$PcA[$p] = GUICtrlCreatePic($PicPath & "block.bmp", $Split[1] + 180, $Split[2] + 50, 15, 15)
	Next
	Global $ir[9] = ["261,146", "261,162", "261,178", _
			"277,146", "277,162", "277,178", _
			"293,146", "293,162", "293,178"]
	$Value = Random(1, 2, 1)
	For $q = $p To $Value + $q
		$Ran_D = Random(1, UBound($ir) - 1, 1)
		$Rrr = StringSplit($ir[$Ran_D], ",")
		$PcA[$q] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($ir, $Ran_D)
	Next
	Global $is[9] = ["381,241", "381,257", "381,273", _
			"397,241", "397,257", "397,273", _
			"413,241", "413,257", "413,273"]
	$Value = Random(1, 2, 1)
	For $r = $q To $Value + $r
		$Ran_D = Random(1, UBound($is) - 1, 1)
		$Rrr = StringSplit($is[$Ran_D], ",")
		$PcA[$r] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($is, $Ran_D)
	Next
	Global $in[9] = ["381,146", "381,162", "381,178", _
			"397,146", "397,162", "397,178", _
			"413,146", "413,162", "413,178"]
	$Value = Random(1, 2, 1)
	For $s = $r To $s + $Value
		$Ran_D = Random(1, UBound($in) - 1, 1)
		$Rrr = StringSplit($in[$Ran_D], ",")
		$PcA[$s] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($in, $Ran_D)
	Next
	GUICtrlSetOnEvent($Gr[2], "CorrectAnW")
EndFunc

Func SetPos2()
	For $p = 1 To 4
		$Split = StringSplit($Warray[$p], ",")
		$PcA[$p] = GUICtrlCreatePic($PicPath & "block.bmp", $Split[1] + 300, $Split[2] + 50, 15, 15)
	Next
	Global $ir[9] = ["261,146", "261,162", "261,178", _
			"277,146", "277,162", "277,178", _
			"293,146", "293,162", "293,178"]
	$Value = Random(1, 2, 1)
	For $q = $p To $Value + $q
		$Ran_D = Random(1, UBound($ir) - 1, 1)
		$Rrr = StringSplit($ir[$Ran_D], ",")
		$PcA[$q] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($ir, $Ran_D)
	Next
	Global $is[9] = ["381,146", "381,162", "381,178", _
			"397,146", "397,162", "397,178", _
			"413,146", "413,162", "413,178"]
	$Value = Random(1, 2, 1)
	For $r = $q To $Value + $r
		$Ran_D = Random(1, UBound($is) - 1, 1)
		$Rrr = StringSplit($is[$Ran_D], ",")
		$PcA[$r] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($is, $Ran_D)
	Next
	Global $in[9] = ["261,241", "261,257", "261,273", _
			"277,241", "277,257", "277,273", _
			"293,241", "293,257", "293,273"]
	$Value = Random(1, 2, 1)
	For $s = $r To $s + $Value
		$Ran_D = Random(1, UBound($in) - 1, 1)
		$Rrr = StringSplit($in[$Ran_D], ",")
		$PcA[$s] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($in, $Ran_D)
	Next
	GUICtrlSetOnEvent($Gr[3], "CorrectAnW")
EndFunc

Func SetPos3()
	For $p = 1 To 4
		$Split = StringSplit($Warray[$p], ",")
		$PcA[$p] = GUICtrlCreatePic($PicPath & "block.bmp", $Split[1] + 180, $Split[2] - 45, 15, 15)
	Next
	Global $in[9] = ["381,241", "381,257", "381,273", _
			"397,241", "397,257", "397,273", _
			"413,241", "413,257", "413,273"]
	$Value = Random(1, 2, 1)
	For $q = $p To $Value + $q
		$Ran_D = Random(1, UBound($in) - 1, 1)
		$Rrr = StringSplit($in[$Ran_D], ",")
		$PcA[$q] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($in, $Ran_D)
	Next
	Global $ir[9] = ["261,241", "261,257", "261,273", _
			"277,241", "277,257", "277,273", _
			"293,241", "293,257", "293,273"]
	$Value = Random(1, 2, 1)
	For $r = $q To $Value + $r
		$Ran_D = Random(1, UBound($ir) - 1, 1)
		$Rrr = StringSplit($ir[$Ran_D], ",")
		$PcA[$r] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($ir, $Ran_D)
	Next
	Global $is[9] = ["381,146", "381,162", "381,178", _
			"397,146", "397,162", "397,178", _
			"413,146", "413,162", "413,178"]
	$Value = Random(1, 2, 1)
	For $s = $r To $s + $Value
		$Ran_D = Random(1, UBound($is) - 1, 1)
		$Rrr = StringSplit($is[$Ran_D], ",")
		$PcA[$s] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($is, $Ran_D)
	Next
	GUICtrlSetOnEvent($Gr[0], "CorrectAnW")
EndFunc

Func SetPos4()
	For $p = 1 To 4
		$Split = StringSplit($Warray[$p], ",")
		$PcA[$p] = GUICtrlCreatePic($PicPath & "block.bmp", $Split[1] + 300, $Split[2] - 45, 15, 15)
	Next
	Global $ir[9] = ["261,146", "261,162", "261,178", _
			"277,146", "277,162", "277,178", _
			"293,146", "293,162", "293,178"]
	$Value = Random(1, 2, 1)
	For $q = $p To $Value + $q
		$Ran_D = Random(1, UBound($ir) - 1, 1)
		$Rrr = StringSplit($ir[$Ran_D], ",")
		$PcA[$q] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($ir, $Ran_D)
	Next
	Global $in[9] = ["261,241", "261,257", "261,273", _
			"277,241", "277,257", "277,273", _
			"293,241", "293,257", "293,273"]
	$Value = Random(1, 2, 1)
	For $r = $q To $Value + $r
		$Ran_D = Random(1, UBound($in) - 1, 1)
		$Rrr = StringSplit($in[$Ran_D], ",")
		$PcA[$r] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($in, $Ran_D)
	Next
	Global $is[9] = ["381,241", "381,257", "381,273", _
			"397,241", "397,257", "397,273", _
			"413,241", "413,257", "413,273"]
	$Value = Random(1, 2, 1)
	For $s = $r To $s + $Value
		$Ran_D = Random(1, UBound($is) - 1, 1)
		$Rrr = StringSplit($is[$Ran_D], ",")
		$PcA[$s] = GUICtrlCreatePic($PicPath & "block.bmp", $Rrr[1], $Rrr[2], 15, 15)
		_ArrayDelete($is, $Ran_D)
	Next
	GUICtrlSetOnEvent($Gr[1], "CorrectAnW")
EndFunc

Func CorrectAnW()
	TurnOff()
	$SetC = 1
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
	$Score += 1
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
	For $i = 0 To UBound($PkA) - 1
		GUICtrlDelete($PkA[$i])
	Next
EndFunc

Func WrongAnW()
	TurnOff()
	$SetC = 1
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	GUICtrlSetData($Time, "04:00")
	_FlashControl($AddPic, 300)
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
	For $i = 0 To UBound($PkA) - 1
		GUICtrlDelete($PkA[$i])
	Next
EndFunc

Func TurnOff()
	For $a = 0 To UBound($Gr)-1
		GUICtrlSetOnEvent($Gr[$a], "")
	Next
EndFunc