;==========================================================================================
; Description:      Brain Pain - Game 3 Level 2
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================
#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit

Local $xPos = -15, $yPos = 5, $SetC, $Count, $Score, $PcA[9], $PdA[9], $REle = Random(0, 10, 1)
Local $Amount[11] = ["15", "33", "23", "30", "30", "28", "15", "30", "21", "28", "34"]
Local $Path[11] = ["Adobe\", "Animated\", "Emotions\", "Software1\", "Software2\", _
		"Wabbit\", "Animals\", "Food\", "Fruit\", "Funny\", "Jap\"]
Local $PicWH[2][11] = [["55", "50", "50", "50", "50", "50", "62", "43", "56", "44", "40"], _
		["55", "50", "50", "50", "50", "50", "62", "43", "58", "49", "52"]]
Local $GUICW[2][11] = [["0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", _
		"0x000000", "0x000000", "0x000000", "0x000000", "0x000000"], _
		["565", "565", "565", "565", "565", "565", "570", "555", "570", "555", "550"]]

$Hui = GUICreate(_ObjDictGetValue($objLang, 'GameName'), $GUICW[1][$REle], 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, $GUICW[1][$REle], 335)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetBkColor(-1, $GUICW[0][$REle])

GUICtrlCreateGraphic($GUICW[1][$REle] - 90, 5, 85, 35)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 45, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(0, 380, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game3Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("04:00", $GUICW[1][$REle] - 80, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 225, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

$Gr3 = GUICtrlCreateGraphic(285, 45, 1, 335)
If $REle > 5 Then
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0xFFFFFF)
	GUICtrlSetColor($Gr3, 0xFFFFFF)
Else
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0x000000)
	GUICtrlSetColor($Gr3, 0x000000)
EndIf
GUISetOnEvent(-3, "Close")

_PlaySong()

For $o = 1 To 15
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 2, "G3-L2")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 3
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func PlayTime()
	$SetC = 0
	Global $TrA[$Amount[$REle]]
	Global $Array[16] = ["5,70", "75,70", "145,70", "215,70", "5,145", "75,145", "145,145", "215,145", "5,220", "75,220", "145,220", "215,220", "5,295", "75,295", "145,295", "215,295"]
	Global $Narry[16] = ["295,70", "365,70", "435,70", "505,70", "295,145", "365,145", "435,145", "505,145", "295,220", "365,220", "435,220", "505,220", "295,295", "365,295", "435,295", "505,295"]
	For $i = 0 To $Amount[$REle] - 1
		$TrA[$i] = $i + 1
	Next

	$val = Random(6, 8, 1)
	For $i = 1 To $val
		$Ran_D = Random(0, UBound($TrA) - 1, 1)
		$Ran_Y = Random(0, UBound($Array) - 1, 1)
		$Spt = StringSplit($Array[$Ran_Y], ",")
		$Spi = StringSplit($Narry[$Ran_Y], ",")
		If $i <> 3 Then
			$PcA[$i] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp", $Spt[1], $Spt[2], $PicWH[0][$REle], $PicWH[1][$REle])
			GUICtrlSetCursor(-1, 0)
			GUICtrlSetOnEvent(-1, "WrongAnW")
			$PdA[$i] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp", $Spi[1], $Spi[2], $PicWH[0][$REle], $PicWH[1][$REle])
			GUICtrlSetCursor(-1, 0)
			GUICtrlSetOnEvent(-1, "WrongAnW")
			_ArrayDelete($TrA, $Ran_D)
		ElseIf $i = 3 Then
			$Ran_D = Random(0, UBound($TrA) - 1, 1)
			$PcA[$i] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp", $Spt[1], $Spt[2], $PicWH[0][$REle], $PicWH[1][$REle])
			GUICtrlSetCursor(-1, 0)
			GUICtrlSetOnEvent(-1, "CorrectAnW")
			_ArrayDelete($TrA, $Ran_D)
			$Ran_D = Random(0, UBound($TrA) - 1, 1)
			$PdA[$i] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp", $Spi[1], $Spi[2], $PicWH[0][$REle], $PicWH[1][$REle])
			GUICtrlSetCursor(-1, 0)
			GUICtrlSetOnEvent(-1, "CorrectAnW")
			_ArrayDelete($TrA, $Ran_D)
		EndIf
		_ArrayDelete($Array, $Ran_Y)
		_ArrayDelete($Narry, $Ran_Y)
	Next
EndFunc

Func CorrectAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	_FlashControl($AddPic, 300)
	$Score += 1
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
	For $i = 0 To UBound($PdA) - 1
		GUICtrlDelete($PdA[$i])
	Next
	TurnON()
EndFunc

Func WrongAnW()
	$SetC = 1
	TurnOFF()
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	_FlashControl($AddPic, 300)
	For $i = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$i])
	Next
	For $i = 0 To UBound($PdA) - 1
		GUICtrlDelete($PdA[$i])
	Next
	TurnON()
EndFunc

Func TurnON()
	For $i = 0 To UBound($PcA) - 1
		GUICtrlSetState($PcA[$i], $GUI_ENABLE)
	Next
	For $i = 0 To UBound($PdA) - 1
		GUICtrlSetState($PdA[$i], $GUI_ENABLE)
	Next
EndFunc

Func TurnOFF()
	GUICtrlSetData($Time, "04:00")
	For $i = 0 To UBound($PcA) - 1
		GUICtrlSetState($PcA[$i], $GUI_DISABLE)
	Next
	For $i = 0 To UBound($PdA) - 1
		GUICtrlSetState($PdA[$i], $GUI_DISABLE)
	Next
EndFunc