;==========================================================================================
; Description:      Brain Pain - Game 16 Level 3
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $xPos = -15, $yPos = 5, $SetC, $Count, $Score, $PcA[4], $PkA[5], $Rnd_D, $n = 0, $x
Local $REle = Random(0, 10, 1)
Local $Amount[11] = ["15", "33", "23", "30", "30", "28", "15", "30", "21", "28", "34"]
Local $Path[11] = ["Adobe\", "Animated\", "Emotions\", "Software1\", "Software2\", _
		"Wabbit\", "Animals\", "Food\", "Fruit\", "Funny\", "Jap\"]
Local $PicWH[2][11] = [["55", "50", "50", "50", "50", "50", "62", "43", "56", "44", "40"], _
		["55", "50", "50", "50", "50", "50", "62", "43", "58", "49", "52"]]
Local $GUICW[2][11] = [["0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", "0xFFFFFF", _
		"0x000000", "0x000000", "0x000000", "0x000000", "0x000000"], _
		["555", "555", "555", "555", "555", "555", "560", "545", "560", "545", "540"]]

$Hui = GUICreate("Brain Pain", $GUICW[1][$REle], 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, $GUICW[1][$REle], 335)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetBkColor(-1, $GUICW[0][$REle])

$Gr0 = GUICtrlCreateGraphic($GUICW[1][$REle] - 90, 5, 85, 35)
GUICtrlSetColor(-1, 0x000000)
$Gr1 = GUICtrlCreateGraphic(0, 45, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Gr2 = GUICtrlCreateGraphic(0, 380, $GUICW[1][$REle], 1)
GUICtrlSetColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game13Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("07:00", $GUICW[1][$REle] - 80, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 225, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)

GUISetState()

If $REle > 5 Then
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0xFFFFFF)
Else
	_PrePare(($GUICW[1][$REle]) - 320, 135, 0x000000)
EndIf

GUISetOnEvent(-3, "Close")

_PlaySong()

For $p = 1 To 20
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 3, "G16-L3")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

Func Timer()
	$Count = 6
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func PlayTime()
	$SetC = 0
	$n = 0
	$x = 0
	Global $TrA[$Amount[$REle]], $PkAay[1]
	For $i = 0 To $Amount[$REle] - 1
		$TrA[$i] = $i + 1
	Next
	For $i = 0 To 3
		$x += 100
		$Ran_D = Random(0, UBound($TrA) - 1, 1)
		$PcA[$i] = GUICtrlCreatePic($PicPath & $Path[$REle] & $TrA[$Ran_D] & ".bmp", _
				$x, 175, $PicWH[0][$REle], $PicWH[1][$REle])
		GUICtrlSetCursor($PcA[$i], 0)
		_ArrayDelete($TrA, $Ran_D)
	Next
	For $i = 0 To 4
		Randomize()
		$PkA[$i] = $Rnd_D
	Next
	$Pos1 = ControlGetPos($Hui, "", $PcA[0])
	$Pos2 = ControlGetPos($Hui, "", $PcA[1])
	$Pos3 = ControlGetPos($Hui, "", $PcA[2])
	$Pos4 = ControlGetPos($Hui, "", $PcA[3])
	Local $Array[4] = [$Pos1[0] & ":" & $Pos1[1], $Pos2[0] & ":" & $Pos2[1], _
			$Pos3[0] & ":" & $Pos3[1], $Pos4[0] & ":" & $Pos4[1]]
	For $a = 0 To UBound($PcA) - 1
		$Ran_Y = Random(0, UBound($Array) - 1, 1)
		$Split = StringSplit($Array[$Ran_Y], ":")
		GUICtrlSetPos($PcA[$a], $Split[1], $Split[2])
		_ArrayDelete($Array, $Ran_Y)
	Next
	GetPos()
EndFunc

Func Randomize()
	Sleep(300)
	$Rnd_D = Random(0, 3, 1)
	If $Rnd_D = 0 Then
		Sleep(300)
		GUICtrlSetPos($PcA[0], 90, 165, $PicWH[0][$REle] + 20, $PicWH[1][$REle] + 20)
		Sleep(300)
		GUICtrlSetPos($PcA[0], 100, 175, $PicWH[0][$REle], $PicWH[1][$REle])
		$Rnd_D = $PcA[0]
	ElseIf $Rnd_D = 1 Then
		Sleep(300)
		GUICtrlSetPos($PcA[1], 190, 165, $PicWH[0][$REle] + 20, $PicWH[1][$REle] + 20)
		Sleep(300)
		GUICtrlSetPos($PcA[1], 200, 175, $PicWH[0][$REle], $PicWH[1][$REle])
		$Rnd_D = $PcA[1]
	ElseIf $Rnd_D = 2 Then
		Sleep(300)
		GUICtrlSetPos($PcA[2], 290, 165, $PicWH[0][$REle] + 20, $PicWH[1][$REle] + 20)
		Sleep(300)
		GUICtrlSetPos($PcA[2], 300, 175, $PicWH[0][$REle], $PicWH[1][$REle])
		$Rnd_D = $PcA[2]
	ElseIf $Rnd_D = 3 Then
		Sleep(300)
		GUICtrlSetPos($PcA[3], 390, 165, $PicWH[0][$REle] + 20, $PicWH[1][$REle] + 20)
		Sleep(300)
		GUICtrlSetPos($PcA[3], 400, 175, $PicWH[0][$REle], $PicWH[1][$REle])
		$Rnd_D = $PcA[3]
	EndIf
	Return $Rnd_D
EndFunc

Func GetPos()
	If $n = 5 Then
		CorrectAnW()
	Else
		$n += 1
	EndIf
	GUICtrlSetOnEvent($PcA[0], "WrongAnW")
	GUICtrlSetOnEvent($PcA[1], "WrongAnW")
	GUICtrlSetOnEvent($PcA[2], "WrongAnW")
	If $PkA[$n - 1] = $PcA[0] Then
		GUICtrlSetOnEvent($PcA[0], "GetPos")
	ElseIf $PkA[$n - 1] = $PcA[1] Then
		GUICtrlSetOnEvent($PcA[1], "GetPos")
	ElseIf $PkA[$n - 1] = $PcA[2] Then
		GUICtrlSetOnEvent($PcA[2], "GetPos")
	ElseIf $PkA[$n - 1] = $PcA[3] Then
		GUICtrlSetOnEvent($PcA[3], "GetPos")
	EndIf
EndFunc

Func CorrectAnW()
	For $a = 0 To UBound($PcA) - 1
		GUICtrlSetOnEvent($PcA[$a], "")
	Next
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	GUICtrlSetData($Time, "07:00")
	_FlashControl($AddPic, 300)
	$Score += 1
	For $a = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$a])
	Next
EndFunc

Func WrongAnW()
	For $a = 0 To UBound($PcA) - 1
		GUICtrlSetOnEvent($PcA[$a], "")
	Next
	$SetC = 1
	If $xPos = 185 Then
		$xPos = -15
		$yPos += 20
	EndIf
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, $yPos, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	GUICtrlSetData($Time, "07:00")
	_FlashControl($AddPic, 300)
	For $a = 0 To UBound($PcA) - 1
		GUICtrlDelete($PcA[$a])
	Next
EndFunc