;==========================================================================================
; Description:      Brain Pain - Game 30 Level 1
; Author(s):        MrBond007 (Baki G)
;					Credits also goes to the authors of Array.au3
;
;					Remember if you like This game and AutoIt Donate to the AutoIt Project:
;					http://www.autoitscript.com/donate.php
;==========================================================================================

#include <Bass.au3>
#NoTrayIcon

Opt("GUIOnEventMode", 1)
Opt("GUICloseOnESC", 0)

If $cmdline[0] > 0 Then
	Switch $cmdline[1]
		Case 'English'
			_getLanguage($objLang, "English")
			IniWrite($languagePath, 'Setting', 'Language', 'English')
		Case 'German'
			_getLanguage($objLang, "German")
			IniWrite($languagePath, 'Setting', 'Language', 'German')
	EndSwitch
Else
	_getLanguage($objLang, "English")
	IniWrite($languagePath, 'Setting', 'Language', 'English')
EndIf

If WinExists(_ObjDictGetValue($objLang, 'GameName')) Then Exit
Local $xPos = -15, $Gra[4], $Dots[9], $jin[12]
Local $SetC, $Count, $Score
$Hui = GUICreate("", 540, 410, -1, -1, BitOR($WS_POPUP, $WS_BORDER))
GUISetBkColor(0xFFD046)

GUICtrlCreateGraphic(0, 46, 540, 335)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGraphic(0, 45, 550, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateGraphic(450, 5, 85, 35)
GUICtrlSetColor(-1, 0x4A66FA)
GUICtrlCreateGraphic(0, 380, 550, 1)
GUICtrlSetColor(-1, 0x000000)
GUICtrlCreateLabel(_ObjDictGetValue($objLang, 'Game30Q'), 5, 390, 600, 15)
GUICtrlSetColor(-1, 0x4A66FA)
$Time = GUICtrlCreateLabel("04:00", 460, 7, 65, 25, $SS_CENTER)
GUICtrlSetFont(-1, 20)
GUICtrlSetColor(-1, 0x4A66FA)
$Label2 = GUICtrlCreateLabel("", 260, 10, 175, 25, $SS_CENTER)
GUICtrlSetFont(-1, 15, 500)
GUICtrlSetColor(-1, 0x4A66FA)
GUISetState()

_PrePare(220, 135, 0x4A66FA)

GUISetOnEvent(-3, "Close")

GUICtrlCreateGraphic(30, 160, 100, 100)
GUICtrlSetColor(-1, 0x000000)
Local $Position[4] = ["250,90", "410,90", "250,240", "410,240"]
For $i = 0 To UBound($Gra) - 1
	$Split = StringSplit($Position[$i], ",")
	$Gra[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 100, 100)
	GUICtrlSetColor(-1, 0x000000)
	GUICtrlSetCursor(-1, 0)
Next

_PlaySong ()

For $i = 1 To 10
	PlayTime()
	Timer()
Next

_Results($Label2, $Score, 1, "G30-L1")
_FlashControl($Label2, 400)
Sleep(1000)
Close()

While 1
	Sleep(100)
WEnd

Func Timer()
	$Count = 3
	While $Count > 0
		For $z = 0 To $Count
			If $SetC = 1 Then $Count = 0
			For $i = 99 To 0 Step - 1
				If $SetC = 1 Then ExitLoop
				If $i < 10 Then $i = "0" & $i
				ControlSetText($Hui, "", $Time, $Count & ":" & $i)
				Sleep(10)
			Next
			$Count -= 1
		Next
	WEnd
	If $SetC <> 1 Then WrongAnW()
EndFunc

Func PlayTime()
	$SetC = 0

	For $i = 0 To UBound($Dots) - 1
		GUICtrlDelete($Dots[$i])
	Next
	For $i = 0 To UBound($jin) - 1
		GUICtrlDelete($jin[$i])
	Next
	For $i = 0 To UBound($Gra) - 1
		GUICtrlSetOnEvent($Gra[$i], "WrongAnW")
	Next

	Local $Colors[4] = ["0xFF0000", "0xFFFF00", "0x0000FF", "0x00FF00"]
	Local $Array[9] = ["40,170", "70,170", "100,170", _
			"40,200", "70,200", "100,200", _
			"40,230", "70,230", "100,230"]
	Local $Manda[4] = ["+220,-70", "+380,-70", "+220,+80", "+380,+80"]

	$Val = 3
	Local $n = $Val + 1
	$Randa = Random(0, UBound($Manda) - 1, 1)
	If $Randa = 0 Then
		_Draw(0, 1, 1, 1)
		GUICtrlSetOnEvent($Gra[0], "CorrectAnW")
	ElseIf $Randa = 1 Then
		_Draw(1, 0, 1, 1)
		GUICtrlSetOnEvent($Gra[1], "CorrectAnW")
	ElseIf $Randa = 2 Then
		_Draw(1, 1, 0, 1)
		GUICtrlSetOnEvent($Gra[2], "CorrectAnW")
	ElseIf $Randa = 3 Then
		_Draw(1, 1, 1, 0)
		GUICtrlSetOnEvent($Gra[3], "CorrectAnW")
	EndIf
	$Splits = StringSplit($Manda[$Randa], ",")
	For $i = 0 To $Val
		$n += 1
		$Ran_D = Random(0, UBound($Colors) - 1, 1)
		$Ran_Y = Random(0, UBound($Array) - 1, 1)
		$Split = StringSplit($Array[$Ran_Y], ",")
		$Dots[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
		GUICtrlSetGraphic($Dots[$i], $GUI_GR_COLOR, $Colors[$Ran_D], $Colors[$Ran_D])
		GUICtrlSetGraphic($Dots[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
		GUICtrlSetBkColor($Dots[$i], 0xFFFFFF)

		$Dots[$n] = GUICtrlCreateGraphic($Split[1] + $Splits[1], $Split[2] + $Splits[2], 20, 20)
		GUICtrlSetGraphic($Dots[$n], $GUI_GR_COLOR, $Colors[$Ran_D], $Colors[$Ran_D])
		GUICtrlSetGraphic($Dots[$n], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
		GUICtrlSetBkColor($Dots[$n], 0xFFFFFF)
		_ArrayDelete($Array, $Ran_Y)
	Next
	_ArrayDelete($Manda, $Randa)
EndFunc

Func _Draw($Cir1, $Cir2, $Cir3, $Cir4)
	Local $Colors[4] = ["0xFF0000", "0xFFFF00", "0x0000FF", "0x00FF00"]
	If $Cir1 = 1 Then
		Local $Marray[9] = ["260,100", "290,100", "320,100", _
				"260,130", "290,130", "320,130", _
				"260,160", "290,160", "320,160"]
		For $i = 0 To 2
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir2 = 1 Then
		Local $Marray[9] = ["420,100", "450,100", "480,100", _
				"420,130", "450,130", "480,130", _
				"420,160", "450,160", "480,160"]
		For $i = 3 To 5
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir3 = 1 Then
		Local $Marray[9] = ["260,250", "290,250", "320,250", _
				"260,280", "290,280", "320,280", _
				"260,310", "290,310", "320,310"]
		For $i = 6 To 8
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf

	If $Cir4 = 1 Then
		Local $Marray[9] = ["420,250", "450,250", "480,250", _
				"420,280", "450,280", "480,280", _
				"420,310", "450,310", "480,310"]
		For $i = 9 To 11
			$Ran_D = Random(0, UBound($Marray) - 1, 1)
			$Ran_Y = Random(0, UBound($Colors) - 1, 1)
			$Split = StringSplit($Marray[$Ran_D], ",")
			$jin[$i] = GUICtrlCreateGraphic($Split[1], $Split[2], 20, 20)
			GUICtrlSetGraphic($jin[$i], $GUI_GR_COLOR, $Colors[$Ran_Y], $Colors[$Ran_Y])
			GUICtrlSetGraphic($jin[$i], $GUI_GR_ELLIPSE, 0, 0, 20, 20)
			GUICtrlSetBkColor($jin[$i], 0xFFFFFF)
			_ArrayDelete($Marray, $Ran_D)
		Next
	EndIf
EndFunc

Func CorrectAnW()
	$SetC = 1
	TurnOFF()
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "Correct.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "Correct.wav")
	_FlashControl($AddPic, 300)
	$Score += 1
EndFunc

Func WrongAnW()
	$SetC = 1
	TurnOFF()
	$xPos += 20
	$AddPic = GUICtrlCreatePic($PicPath & "False.bmp", $xPos, 15, 16, 16)
	SoundPlay($SoundPath & "False.wav")
	_FlashControl($AddPic, 300)
EndFunc

Func TurnOFF()
	GUICtrlSetData($Time, "04:00")
	For $i = 0 To UBound($Gra) - 1
		GUICtrlSetOnEvent($Gra[$i], "")
	Next
EndFunc